/**
 * Created by aaron on 17/2/10.
 */
import React,{Component, PureComponent} from 'react';
import {
    Text,
} from 'react-native';

import {
    BaseViewComponent
} from 'wm-react-native-base';

/**
 * 封装Text
 */
export default class WMText extends BaseViewComponent{

    // 构造
    constructor(props) {
        super(props);
        this.state = {isShow:true, text:this.props.text}
    }

    componentWillReceiveProps(nextProps){
        if(nextProps){
            this.setState({...nextProps});
        }
    }

    render(){
        if(!this.state.isShow){
            return null;
        }
        return (
            <Text ref={'wmTxt'} {...this.props}>{this.state.text}</Text>
        );
    }
    
    /**
     * 当前是否已经显示
     */
    isShow = ()=>{
        return this.state.isShow;
    }

    /**
     * 隐藏
     */
    hidden = ()=>{
        this.setState({isShow:false});
    }

    /**
     * 显示
     */
    show = ()=>{
        this.setState({isShow:true});
    }

    /**
     * 设置text
     */
    setText = (text, callback)=>{
        text = text || '';
        this.setState({text:text}, callback);
    }

    /**
     * 获取text
     */
    getText = ()=>{
        return this.state.text;
    }

    /**
     *
     * @param props
     */
    setNativeProps = (props)=>{
        this.refs.wmTxt && this.refs.wmTxt.setNativeProps(props);
    }

}